/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.dokumente.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.dokumente.entity.DokumentVorlage;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractDokumentVorlageSearch {

  @Inject
  protected transient DokumentVorlageExtendedDAO dao;

  public AbstractDokumentVorlageSearch() {
    super();
  }

  public List<DokumentVorlage> getSearchResult(DokumentVorlageSearchParameters searchParameters, EagerLoadingCollector<DokumentVorlage> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<DokumentVorlage> querySearchResult(DokumentVorlageSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
